package info.aspirecn.iov.sjjh.shupplier10000005.action;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.iov.sjjh.shupplier10000005.SjjhConstant;
import info.aspirecn.iov.sjjh.shupplier10000005.service.PhotoIdentityCheckService;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;

/**
 * @author xusonglin
 * @version V1.0
 **/
@Slf4j
@RestController
public class PhotoCheckAction implements PhotoCheckActionInterface {
    /**UTF-8*/
    private static final String UTF8_ENCODE = "UTF-8";
    /**日志参数中的错误参数名*/
    private static final String LOG_ERROR_PARA = "respnoseCode";
    /**日志参数中的是否收费*/
    private static final String LOG_FEE_PARA = "isCharge";

    @Autowired
    private PhotoIdentityCheckService photoIdentityCheckService;

    @Override
    public ChannelTypeHandleResponseObject photoIdentityCheckAes(
            @RequestHeader(name = "channelId") String channelId,
            @RequestParam(name = "outTime", required = true) Integer outTime,
            @RequestBody String customBody) {
        HttpServletRequest request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes())
                .getRequest();

        //调用service
        ChannelTypeHandleResponseObject ret;
        JSONObject jsonObject = JSON.parseObject(customBody);
        ret = photoIdentityCheckService.photoIdentityCheck(request, customBody, outTime, SjjhConstant.DECODE_TYPE_AES);
        jsonObject = null;

        //把接口参数、调用结果和是否收费放入访问日志中
        if (ret.getCode() != Constant.SUCCESS) {
            request.setAttribute(SjjhConstant.Charge_Log_ResponseCode, Constant.CHANNEL_LOG_ERROR_CODE);
        } else {
            request.setAttribute(SjjhConstant.Charge_Log_ResponseCode, Constant.CHANNEL_LOG_SUCCESS_CODE);
        }
        request.setAttribute(SjjhConstant.Charge_Log_Key, ret.getIsCharge());

        request.setAttribute(Constant.CHANNEL_TYPE_KEY, Constant.CHANNEL_TYPE_SYNC);
        return ret;
    }

    @Override
    public ChannelTypeHandleResponseObject photoIdentityCheckV2(
            @RequestHeader(name = "channelId") String channelId,
            @RequestParam(name = "outTime", required = true) Integer outTime,
            @RequestBody String customBody) {
        HttpServletRequest request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes())
                .getRequest();

        //调用service
        ChannelTypeHandleResponseObject ret;
        JSONObject jsonObject = JSON.parseObject(customBody);
        ret = photoIdentityCheckService.photoIdentityCheckV2(request, customBody, outTime, SjjhConstant.DECODE_TYPE_AES);
        jsonObject = null;

        //把接口参数、调用结果和是否收费放入访问日志中
        if (ret.getCode() != Constant.SUCCESS) {
            request.setAttribute(SjjhConstant.Charge_Log_ResponseCode, Constant.CHANNEL_LOG_ERROR_CODE);
        } else {
            request.setAttribute(SjjhConstant.Charge_Log_ResponseCode, Constant.CHANNEL_LOG_SUCCESS_CODE);
        }
        request.setAttribute(SjjhConstant.Charge_Log_Key, ret.getIsCharge());

        request.setAttribute(Constant.CHANNEL_TYPE_KEY, Constant.CHANNEL_TYPE_SYNC);
        return ret;
    }

}
